# OE: conditional switches
#
#(ie. use with rpm --rebuild):
#
#	--with diet	Compile thttpd against dietlibc

%define build_diet 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_diet: %{expand: %%define build_diet 1}}

%define	name	thttpd
%define	version	2.24
%define	release	1mdk

Summary:	Throttleable lightweight httpd server
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	BSD
Group:		System/Servers
URL:		http://www.acme.com/software/thttpd
Source0:	%{name}-%{version}.tar.bz2
Source1:	%{name}.init.bz2
Source2:	%{name}.conf.bz2
Source3:	%{name}.logrotate.bz2
PreReq:		rpm-helper
Provides:	webserver
BuildRoot:	%{_tmppath}/%{name}-buildroot

%if %{build_diet}
BuildRequires:	dietlibc-devel >= 0.20-1mdk
%endif

%description
Thttpd is a very compact no-frills httpd serving daemon that can
handle very high loads.  While lacking many of the advanced
features of Apachee, thttpd operates without forking and is
extremely efficient in memory use.  Basic support for cgi scripts,
authentication, and ssi is provided for. Advanced features include
the ability to throttle traffic.

%prep

%setup -q

bzcat %{SOURCE1} > %{name}.init
bzcat %{SOURCE2} > %{name}.conf
bzcat %{SOURCE3} > %{name}.logrotate

%build

%if %{build_diet}
export CC="diet gcc"
export CCOPT="-Os -static -nostdinc -D_BSD_SOURCE"
export CFLAGS="-Os -static -nostdinc -D_BSD_SOURCE"
%configure
%else
%configure
%endif

%make \
    prefix=%{_prefix} \
    BINDIR=%{_sbindir} \
    MANDIR=%{_mandir} \
    WEBDIR=/var/lib/%{name} \
    WEBGROUP=%{name} \
    CGIBINDIR=/var/lib/%{name}/cgi-bin

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}/var/lib/%{name}/cgi-bin
install -d %{buildroot}/var/log/%{name}
install -d %{buildroot}/var/run/%{name}
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man{1,8}

install -m0755 %{name} %{buildroot}%{_sbindir}/%{name}
install -m0755 extras/htpasswd %{buildroot}%{_sbindir}/%{name}-htpasswd
install -m0755 extras/makeweb %{buildroot}%{_sbindir}/
install -m0755 extras/syslogtocern %{buildroot}%{_sbindir}/
install -m0644 extras/htpasswd.1 %{buildroot}%{_mandir}/man1/%{name}-htpasswd.1
install -m0644 extras/makeweb.1 %{buildroot}%{_mandir}/man1/
install -m0644 extras/syslogtocern.8 %{buildroot}%{_mandir}/man8/
install -m0644 thttpd.8 %{buildroot}%{_mandir}/man8/

install -m0755 cgi-bin/printenv %{buildroot}/var/lib/%{name}/cgi-bin/printenv.cgi
install -m0755 cgi-src/phf %{buildroot}/var/lib/%{name}/cgi-bin/
install -m0755 cgi-src/redirect %{buildroot}/var/lib/%{name}/cgi-bin/
install -m0755 cgi-src/ssi %{buildroot}/var/lib/%{name}/cgi-bin/
install -m0644 cgi-src/redirect.8 %{buildroot}%{_mandir}/man8/
install -m0644 cgi-src/ssi.8 %{buildroot}%{_mandir}/man8/

install -m0755 %{name}.init  %{buildroot}%{_initrddir}/%{name}
install -m0755 %{name}.logrotate  %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -m0644 %{name}.conf %{buildroot}%{_sysconfdir}/%{name}.conf
install -m0644 index.html %{buildroot}/var/lib/%{name}/index.html

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
%_post_service %{name}

%preun
%_preun_service %{name}

%pre 
%_pre_useradd %{name} /var/lib/%{name} /bin/sh

%postun
%_postun_userdel %{name}

%files
%defattr(-,root,root)
%doc README TODO
%config(noreplace) %attr(0644,root,root)  %{_sysconfdir}/%{name}.conf
%config(noreplace) %attr(0755,root,root)  %{_initrddir}/%{name}
%config(noreplace) %attr(0644,root,root)  %{_sysconfdir}/logrotate.d/%{name}
%attr(2755,%{name},%{name}) %{_sbindir}/makeweb
%attr(0755,root,root) %{_sbindir}/%{name}-htpasswd
%attr(0755,root,root) %{_sbindir}/syslogtocern
%attr(0755,root,root) %{_sbindir}/%{name}
%attr(0755,%{name},%{name}) %dir /var/lib/%{name}
%attr(0755,%{name},%{name}) %dir /var/lib/%{name}/cgi-bin
%attr(0755,%{name},%{name}) %dir /var/log/%{name}
%attr(0755,%{name},%{name}) %dir /var/run/%{name}
%config(noreplace) %attr(0644,root,root) /var/lib/%{name}/index.html
%attr(0755,root,root) /var/lib/%{name}/cgi-bin/printenv.cgi
%attr(0755,root,root) /var/lib/%{name}/cgi-bin/phf
%attr(0755,root,root) /var/lib/%{name}/cgi-bin/redirect
%attr(0755,root,root) /var/lib/%{name}/cgi-bin/ssi
%attr(0644,root,root) %{_mandir}/man*/*

%changelog
* Mon Nov 03 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.24-1mdk
- 2.24
- drop P0 & P1, it's included
- drop S4
- rearrange the web root (think msec safe)
- fix pid dir, S1 & S2
- added logrotate stuff

* Thu Jan 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.20c-2mdk
- build release

* Wed Oct 30 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.20c-1mdk
- use spec file magic to enable compilation against dietlibc, use
  "rpm --rebuild --with diet thttpd-2.20c-1mdk.src.rpm"
- added S1, S2 & S3
- added P1 from 2.23beta1
- initial cooker contrib (ripped from RH, adapted for ML)
